/*
    Akonadi OpenSync 0.22 implementation library
    Copyright (C) 2010 Tejas Guruswamy <masterpatricko@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/

#ifndef AKONADISYNC_H
#define AKONADISYNC_H

#include <Akonadi/Collection>

#include "akonadisync_wrapper.h"

namespace Akonadi
{
  class Item;
}

struct OSyncChange;

class AkonadiSync: public QObject, public AkonadiSyncWrapper
{
    Q_OBJECT
    
	public:
        AkonadiSync(qint64 contacts, qint64 events);
		
        virtual bool initialize(int enabledtypes);
        virtual bool updateItem(OSyncChange* chg, bool getData);
        virtual QList<OSyncChange*> listItems();
        virtual bool deleteItem(OSyncChange* chg);
        virtual bool addItem(OSyncChange* chg);
        virtual bool modifyItem(OSyncChange* chg);
		
	private:
		Akonadi::Collection::List m_cols;
        Akonadi::Collection::Id m_contact_col;
        Akonadi::Collection::Id m_event_col;
        int m_enabledtypes;
        
        bool fetchCollections();
        Akonadi::Collection getCollection(Akonadi::Collection::Id id);
        QByteArray getPayload(Akonadi::Item item);
        void setPayload(Akonadi::Item &item, OSyncChange* chg);
};

#endif // AKONADISYNC_H
